/**************************************************************************************************

Written by Tsunehiko Kato
Copyright (c) 2015   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "unicode_string_table.h"
#include  <tchar.h>
#include  "string_util.h"




//--------
//  Init
//--------
void
unicode_string_table::clear()
{
	key_ID_map.clear();
	vStrings.clear();
	vKey.clear();
}



int
unicode_string_table::set_string(const std::string& key, const std::string& str)
{
	int ID;


	if ( !is_defined_key(key) ) {
		// VKo^
		ID = vStrings.size();
		vStrings.push_back( str );
		key_ID_map[key] = ID;
		vKey.push_back(key);
	} else {
		// ㏑
		ID = key_ID_map[key];
		vStrings[ID] = str;
	}

	return  ID;
}




//-------------
//  Get / Set
//-------------
int
unicode_string_table::get_ID(const std::string& key)  const
{
	std::map<std::string, int>::const_iterator  it = key_ID_map.find(key);

	// `̃L[
	if (it == key_ID_map.end())  {
		return -1;
	}

	return  it->second;
}


const std::string&
unicode_string_table::get_string(const std::string& key)  const
{
	int ID = get_ID(key);

	// `̃L[
	if (ID < 0)  {
		return key;
	}
	
	return  vStrings[ID];
}





//--------
//  Load
//--------


bool
load_key_value(FILE* fp, std::string& key, std::string& val)
{
	const int NBUF = 512;
	char buf[NBUF];

	// Psǂݍ
	if (fgets(buf, NBUF, fp) == NULL) {
		return  false;
	}


	std::vector<std::string> elems;
	elems = split2(remove_cpp_comment(buf), ":");

	if (elems.size() < 2) {
		return false;
	}
	else if (elems.size() > 2) {
		for (int i = 2; i < elems.size(); i++) {
			elems[1] += ":" + elems[i];
		}
	}

	key = trim(elems[0], " \t\n");
	val = trim(elems[1], " \t\n");
	val = trim(val, "\"");

	return  true;
}




bool
unicode_string_table::load_utf8(FILE* fp)
{
	while (true) {
		std::string key, value;

		//--  Load key and value
		if (!load_key_value(fp, key, value)) {
			if (feof(fp) != 0)  break;
			continue;
		}

		//--  Register key and value
		set_string(key, value);
	}

	return  true;
}

